﻿#region Copyright Syncfusion Inc. 2001 - 2011
// Copyright Syncfusion Inc. 2001 - 2011. All rights reserved.
// Use of this code is subject to the terms of our license.
// A copy of the current license can be obtained at any time by e-mailing
// licensing@syncfusion.com. Any infringement will be prosecuted under
// applicable laws. 
#endregion
using System;
using System.Windows.Forms;
using Syncfusion.Pdf.Parsing;
using Syncfusion.Windows.Forms.PdfViewer;
using Syncfusion.Pdf.Exporting;
using Syncfusion.Pdf.Graphics;
using Syncfusion.Pdf;
using System.Drawing;
using System.IO;

namespace GettingStarted
{
    public partial class Form1 : Form
    {
        # region Constructor
        public Form1()
        {
            InitializeComponent();
        }
        # endregion

        # region Events

        private void Form1_Load(object sender, EventArgs e)
        {
            //Read the tiff image 
            byte[] file = File.ReadAllBytes(@"..\..\Data\HTTP Succinctly.tiff");

            //convert the image byte to pdf byte 
            byte[] result = GetCompressedPDFDocumentFromMultipageTif(file);
            //Initialize PdfLoadedDocument
            PdfLoadedDocument ldoc = new PdfLoadedDocument(result);
            
            pdfViewerControl1.Load(ldoc);
        }
        #endregion

        #region HelperMethods
        private static byte[] GetCompressedPDFDocumentFromMultipageTif(MemoryStream docStream)
        {
            var document = new PdfDocument { Compression = PdfCompressionLevel.Best };

            //get the image stream and draw frame by frame 
            using (var tiffImage = new PdfBitmap(docStream))
            {

                int frameCount = tiffImage.FrameCount;
                for (int i = 0; i < frameCount; i++)
                {
                    //add the page 
                    var page = document.Pages.Add();
                    //Page settings 
                    document.PageSettings.Margins.All = 0;

                    //create graphics 
                    var g = page.Graphics;
                    tiffImage.ActiveFrame = i;

                    //draw tiff frame 
                    g.DrawImage(tiffImage, 0, 0, page.GetClientSize().Width, page.GetClientSize().Height);
                }
            }

            //return the document as stream
            MemoryStream ms = new MemoryStream();
            document.Save(ms);
            return ms.ToArray();

        }

        public static byte[] GetCompressedPDFDocumentFromMultipageTif(byte[] doc)
        {

            using (var docStream = new MemoryStream(doc))
            {

                return GetCompressedPDFDocumentFromMultipageTif(docStream);
            }
        }


        #endregion
    }
}